{****************************************************************************
 * Unit Ports for port actions. 1999 by Stefan Goehler. Freely copy- and    *
 * distributeable.                                                          *
 * Useful if you have to write software for both BP and FPC or if you need  *
 * 32 Bits port access in BP                                                *
 ****************************************************************************}
unit ports;
interface

  procedure outp(port : word;value : byte);
  procedure outpw(port,value : word);
  procedure outpl(port : word;value : longint);
  function  inp(port : word) : byte;
  function  inpw(port : word) : word;
  function  inpl(port : word) : longint;


implementation

procedure outp(port : word;value : byte);assembler;
asm
  mov   dx,port
  mov   al,value
  out   dx,al
end;

procedure outpw(port,value : word);assembler;
asm
  mov   dx,port
  mov   ax,value
  out   dx,ax
end;

procedure outpl(port : word;value : longint);assembler;
asm
         mov   dx,port
  db 66h;mov   ax,value.word
  db 66h;out   dx,ax
end;

function inp(port : word) : byte;assembler;
asm
  mov   dx,port
  in    al,dx
end;

function inpw(port : word) : word;assembler;
asm
  mov   dx,port
  in    ax,dx
end;

function inpl(port : word) : longint;assembler;
asm
         mov   dx,port
  db 66h;in    ax,dx
  db 66h;mov   dx,ax
  db 66h;shr   dx,16
end;

begin
end.
