{Small demo program to show how to make use of the PCI driver. This may
 help you to produce your own drivers for GrafX2.}
uses drv_pci,crt;
const
 devicestr : array[0..15] of string=('Older GFX card','Device Controller','Network',
                                     'Display Controller','Multimedia Device',
                                     'Memory Controller','Bridge Device',
                                     '','','','','','USB Controller','','','');

 deviceinfo : array[0..15,0..5] of string=
            (
            ('','','','','',''),
            ('SCSI','IDE','','','',''),
            ('','Ethernet','Token Ring','','',''),
            ('VGA','8514','XGA','','',''),
            ('Video','Audio','','','',''),
            ('RAM','FLASH','','','',''),
            ('CPU to PCI','ISA bridge','EISA bridge',
             'MC Bridge','PCI to PCI','PCMCIA'),
            ('','','','','',''),
            ('','','','','',''),
            ('','','','','',''),
            ('','','','','',''),
            ('','','','','',''),
            ('','','','','',''),
            ('','','','','',''),
            ('','','','','',''),
            ('','','','','','')
            );

function hexstr(l : longint;width : word) : string;
{ Get from longint value hex-string }
const
  hexs : array[0..15] of char=
  ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
var
  s : string[10];
  i : longint;
begin
  s := '';
  for i := 0 to width-1 do
  begin
    s := hexs[l and 15]+s;
    l := l shr 4;
  end;
  hexstr := s;
end;

var
  i    : integer;
  info : tpcidevinfo;
begin
  clrscr;
  writeln(' Bus  Dev  VendorID  DeviceID            DeviceType  DeviceSubType');
  writeln;

  i := 0;
  repeat
    if pcigetdevinfo(i,info) then begin
      write(' ',i shr 4:3);
      write(i and $F:5);
      write(hexstr(info.vendorid,4):9,'h');
      write(hexstr(info.deviceid,4):9,'h');
      write(devicestr[info.class shr 8 and $F]:22);
      write(deviceinfo[info.class shr 8 and $F,info.class and $F]:15);
      writeln;
    end;
    inc(i);
  until (i = pcigetmaxdev);
  writeln;
  writeln('Press any key to exit...');
  readkey;
end.

